package com.fp.persistence.pgeneral.gene;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import javax.persistence.GeneratedValue;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;

import java.lang.reflect.Field;

import javax.persistence.Transient;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENETRANSACTIONQUERY*/
@Entity(name="TgeneTransactionQuery")
@Table(name="TGENETRANSACTIONQUERY")
public class TgeneTransactionQuery extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneTransactionQuery
*/
@EmbeddedId
@GenericGenerator(name = "seq_id", strategy = "com.fp.general.keygen.SubSequenceKey", parameters = {
        @Parameter(name = "sql", value = "select coalesce(max(SEQUENCE),0)+1 from TGENETRANSACTIONQUERY "
                + "where TRANSACTIONMODULE=:transactionmodule " + "and TRANSACTIONCODE=:transactioncode "
                + "and TRANSACTIONVERSION=:transactionversion "),
        @Parameter(name = "type", value = "java.lang.Integer"),
        @Parameter(name = "param", value = "transactionmodule,pk.transactionmodule;transactioncode,pk.transactioncode;transactionversion,pk.transactionversion"),
        @Parameter(name = "field", value = "sequence") })
@GeneratedValue(generator = "seq_id")
private TgeneTransactionQueryKey pk;
@Column(name="PROCESSCODE", nullable=true)

/**
* Paquete clase de un comando a ejecutar.
*/
private String processcode;

@Column(name="CATALOGTYPEPROCESS", nullable=true)

/**
* Codigo de catalogo  GEN proceso general consulta, mantenimiento, TRA a nivel de transaccion finacniera, ITEM a niveld e rubro de una trnsaccion financiera, BATH comandos de fin de dia
*/
private String catalogtypeprocess;

@Column(name="CATALOGCODETYPEPROCESS", nullable=true)

/**
* Codigo de tabla de catalogo del proceso de negocio de la aplicacion
*/
private String catalogcodetypeprocess;

@Column(name="EXECUTIONORDER", nullable=true)

/**
* orden de ejecucion de la regla de negocio.
*/
private Integer executionorder;

@Column(name="STATUS", nullable=true)

/**
* A indica que la regla esta activa, I regla Inactiva
*/
private String status;

@Column(name="ISFLOW", nullable=true)

/**
* Y Indica que el origen de ejecucion del componente es un flujo del bpm
*/
private String isflow;

@Column(name="RULENAME", nullable=true)

/**
* Nombre de la regla a ejecutar
*/
private String rulename;

@Column(name="PROCESSNAME", nullable=true)

/**
* Nombre del flujo bpm a ejecutar
*/
private String processname;

/**Contructor por defecto*/
public TgeneTransactionQuery(){
}
/**Contructor de TgeneTransactionQuery
@param pPk Clave Primaria del entity
*/
public TgeneTransactionQuery(TgeneTransactionQueryKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneTransactionQuery
*/
public static TgeneTransactionQuery find(EntityManager pEntityManager,TgeneTransactionQueryKey pKey) throws Exception{
    TgeneTransactionQuery obj = pEntityManager.find(TgeneTransactionQuery.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneTransactionQuery
@return El objeto que referencia a la Clave primaria de TgeneTransactionQuery
*/
public TgeneTransactionQueryKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneTransactionQuery
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneTransactionQuery
*/
public void setPk(TgeneTransactionQueryKey pPk){
  pk=pPk;
}
/**Obtiene el valor de processcode
@return valor de processcode*/
public String getProcesscode(){
  return processcode;
}
/**Fija el valor de processcode
@param pProcesscode nuevo Valor de processcode*/
public void setProcesscode(String pProcesscode){
  processcode=pProcesscode;
}

/**Obtiene el valor de catalogtypeprocess
@return valor de catalogtypeprocess*/
public String getCatalogtypeprocess(){
  return catalogtypeprocess;
}
/**Fija el valor de catalogtypeprocess
@param pCatalogtypeprocess nuevo Valor de catalogtypeprocess*/
public void setCatalogtypeprocess(String pCatalogtypeprocess){
  catalogtypeprocess=pCatalogtypeprocess;
}

/**Obtiene el valor de catalogcodetypeprocess
@return valor de catalogcodetypeprocess*/
public String getCatalogcodetypeprocess(){
  return catalogcodetypeprocess;
}
/**Fija el valor de catalogcodetypeprocess
@param pCatalogcodetypeprocess nuevo Valor de catalogcodetypeprocess*/
public void setCatalogcodetypeprocess(String pCatalogcodetypeprocess){
  catalogcodetypeprocess=pCatalogcodetypeprocess;
}

/**Obtiene el valor de executionorder
@return valor de executionorder*/
public Integer getExecutionorder(){
  return executionorder;
}
/**Fija el valor de executionorder
@param pExecutionorder nuevo Valor de executionorder*/
public void setExecutionorder(Integer pExecutionorder){
  executionorder=pExecutionorder;
}

/**Obtiene el valor de status
@return valor de status*/
public String getStatus(){
  return status;
}
/**Fija el valor de status
@param pStatus nuevo Valor de status*/
public void setStatus(String pStatus){
  status=pStatus;
}

/**Obtiene el valor de isflow
@return valor de isflow*/
public String getIsflow(){
  return isflow;
}
/**Fija el valor de isflow
@param pIsflow nuevo Valor de isflow*/
public void setIsflow(String pIsflow){
  isflow=pIsflow;
}

/**Obtiene el valor de rulename
@return valor de rulename*/
public String getRulename(){
  return rulename;
}
/**Fija el valor de rulename
@param pRulename nuevo Valor de rulename*/
public void setRulename(String pRulename){
  rulename=pRulename;
}

/**Obtiene el valor de processname
@return valor de processname*/
public String getProcessname(){
  return processname;
}
/**Fija el valor de processname
@param pProcessname nuevo Valor de processname*/
public void setProcessname(String pProcessname){
  processname=pProcessname;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneTransactionQuery))return false;
    TgeneTransactionQuery that = (TgeneTransactionQuery) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneTransactionQuery
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneTransactionQuery
*/
public Object createInstance(){
 TgeneTransactionQuery instance=new TgeneTransactionQuery();	
 instance.setPk(new TgeneTransactionQueryKey());
 return instance;
}
/**Clona la entidad TgeneTransactionQuery
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneTransactionQuery p=(TgeneTransactionQuery)this.clone();
  p.setPk((TgeneTransactionQueryKey)this.pk.cloneMe());
  return p;
}
}
